//*****************************************************************************
//              \ /
// No Copyright (c) 2003
//              / \
// No rights reserved. This material contains published,
// non-copyrighted work, which includes non-confidential and
// non-proprietary information of Kurt Santel.
//
// Source: Arena.h
//
// Description: Server-side Arena class which describes the arena where
//              the robots will live
//
//*****************************************************************************

#pragma once

#include "../CodeWarCommon/CodeWarTypes.h"
#include "Square.h"
#include <vector>

// Each Arena consists of m_width x m_height Square instances
class Arena
{
public:
    Arena(XType width, YType height);
    ~Arena(void);

    XType getWidth(void) const { return( m_width ); }
    YType getHeight(void) const { return( m_height ); }

    Square * getSquare(XType x, YType y);
    void getRandomSquare(Square * * square);

private:
    XType m_width;
    YType m_height;

    std::vector<std::vector<Square> > m_Squares;
};
