#pragma once

#include <d3dx8mesh.h>

class D3DBox
{
public:
    D3DBox(void);
    ~D3DBox(void);

    bool create(IDirect3DDevice8 * pd3dDevice);

    bool setColor(float r, float g, float b);

    void move(float x, float y, float z);
    void scale(float x, float y, float z);

    bool draw(void);

private:
    IDirect3DDevice8 * m_pd3dDevice;

    struct Vertex
    {
        float x, y, z; // Position of vertex in 3D space
        DWORD diffuse; // Diffuse color of vertex
    };

    LPD3DXMESH m_pBoxMesh;

    D3DXMATRIX m_mMove;
    D3DXMATRIX m_mScale;

    float m_red, m_green, m_blue;

    double m_CurrentTime;
    double m_LastTime;
};
